#include "../include/uint.h"

Unit::Unit(int pt, int ct){
	mpt = pt;
	mct = ct;
	mptct = pt * ct;
}

Unit::~Unit(){
}


float Unit::getVoltage(uint16_t v, float cof) {
	return ((float)v * (float)mpt * EAU_VOL_UNIT / cof);
}

float Unit::getFrequency(uint16_t v) {
	return ((float)v * FRE_UNIT);
}

float Unit::getPower(int16_t v, float cof, bool isPositive) {
	float f;
	if(isPositive) {
		f = (((float)v * EAU_POW_UNIT *  (float)mptct) / cof);
	}else{
		f = (((float)v * EAU_POW_UNIT *  (float)mptct) / cof) * (-1.0);
	}
	return f;
}
