

#include "../include/util.h"

void my_setbit(unsigned char *buf, int n, int v) {
	unsigned char mask = 0x01 << (n % 8);
	if (v)
		buf[n/8] |= mask;
	else
		buf[n/8] &= ~mask;
}

unsigned char my_getbit(unsigned char *buf, int n) {
	unsigned char mask = 0x01 << (n % 8);

	return ((buf[n/8] & mask) ? 1 : 0);
}

uint32_t systerm_time() {
	struct timeval tv;
    gettimeofday(&tv,NULL);
    return (tv.tv_sec*1000 + tv.tv_usec/1000);  //毫秒
}


void msleep(unsigned long msec) {
    struct timeval tv;
    tv.tv_sec = msec / 1000;
    tv.tv_usec = (msec % 1000) * 1000;
    select(0, NULL, NULL, NULL, &tv);
}

const float F_EPSINON = 0.00001;

unsigned short float2u16(float f) {
	if(f > F_EPSINON) {
		return (unsigned short)(f + 0.5);
	}else {
		return (unsigned short)(f - 0.5);
	}
}

int float2int32(float f) {
	if(f > F_EPSINON) {
		return (int)(f + 0.5);
	}else {
		return (int)(f - 0.5);
	}
}
short float2int16(float f) {
	if(f > F_EPSINON) {
		return (short)(f + 0.5);
	}else {
		return (short)(f - 0.5);
	}
}







